/*
 * This Java source file was generated by the Gradle 'init' task.
 */
package com.ristekacademy.simpleCalculator;

import org.junit.jupiter.api.Test;
import static org.junit.jupiter.api.Assertions.*;

class AppTest {
    @Test void additionTest(){
        App classUnderTest = new App();
        assertEquals(6, classUnderTest.add(1,5));
    }

    @Test void subtractionTestPositiveResult(){
        App classUnderTest = new App();
        assertEquals(1, classUnderTest.subtract(3,2));
    }

    @Test void subtractionTestNegativeResult(){
        App classUnderTest = new App();
        assertEquals(-2, classUnderTest.subtract(3,5));
    }

    @Test void multiplicationTestPositiveAndPositive() {
        App classUnderTest = new App();
        assertEquals(15, classUnderTest.multiply(3,5));
    }

    @Test void multiplicationTestPositiveAndNegative() {
        App classUnderTest = new App();
        assertEquals(-18, classUnderTest.multiply(-3,6));
    }

    @Test void multiplicationTestNegativeAndNegative() {
        App classUnderTest = new App();
        assertEquals(30, classUnderTest.multiply(-3,-10));
    }

    @Test void divisionTestPositivePositiveOperands(){
        App classUnderTest = new App();
        assertEquals(2, classUnderTest.divide(10,5));
    }

    @Test void divisionTestPositiveNegativeOperands(){
        App classUnderTest = new App();
        assertEquals(-2, classUnderTest.divide(10,-5));
    }

    @Test void divisionTestNegativePositiveOperands(){
        App classUnderTest = new App();
        assertEquals(-3, classUnderTest.divide(-6,2));
    }

    @Test void divisionTestNegativeNegativeOperands(){
        App classUnderTest = new App();
        assertEquals(4, classUnderTest.divide(-8,-2));
    }

    @Test void divisionTestPositiveRounding(){
        App classUnderTest = new App();
        assertEquals(0, classUnderTest.divide(1,2));
    }

    @Test void divisionTestNegativeRounding(){
        App classUnderTest = new App();
        assertEquals(-1, classUnderTest.divide(-4,3));
    }

    @Test void divisionByZeroExceptionThrown(){
        App classUnderTest = new App();
        assertThrows(ArithmeticException.class, () -> {classUnderTest.divide(1,0);});
    }
}
